{   
   AdcKeys_A.fth
   needs AutoP.fth
   
   02.04.23 Christof Eberspaecher 
   
   Read 6 Key Switches with one pin
   Resistor ladder R=220
   GND R SW1 R SW2 R SW3 R SW4 R SW5 R SW6 3V3
   All Switches connected to keysPin=P40, which has an internal pulldown 15k and adc

}

!polls \ clear multitasking

IFDEF *Tests*	
    oldorgT org
    FORGET *Tests*	 }

pub *Tests*	    PRINT" P2 Test" ;

0 bytes oldorgT

: aKeys_Library ; \ { ################################################################

40 := keysPin

---					%AAAA_BBBB_FFF_PPPPPPPPPPPPP_TT_MMMMM_0
---					%..............0100 	Schmitt trigger A → IN, output feedback
---					%AAAA_BBBB_FFF_PPPP_PPPPPPPPP_TT_MMMMM_0
---					%xxxx_xxxx_xxx_xxxx_SIOHHHLLL_xx_xxxxx_x
---					%1098_7654_321_0987_654321098_76_54321_0
---					%0000_0000_000_0100_101110110_01_10010_0 	;
   
pub adcDrive ( cycles -- )		
   OPEN SOURCE 15K sink
 \ %101_00 ' 990 ohm, 3.3V DAC mode
 \                 %01      ' Output enabled, overrides DIR
 \                    %00011_0 ' DAC 16-bit dither, PWM
 \ %101_000_0000000_01_00011 \ DAC
 
 \  PPP_PPP_PPPPPPP_TT_MMMMM_0
 \  MMM_MMM_MMMMMMM_TT_SSSSS_0
 \ %100 ADC
 \      011 Pin 1*
 \                     01111 periodic/continuous: inc on A-high
 \ %100_011_0000000_00_01111 WRFNC \ orig ADC shifts one to left
 \                  01 Output enabled, overrides DIR
   %100_011_0000000_01_01111 WRFNC \ shifts one to left
   \ L drive smartpin LOW so enable pulldown is in WRFNC
   ( cycles ) WXPIN 
   0 WYPIN ;
  

: aKeys. 
   keysPin pin
   
   10_000 adcDrive 
   
   KEY drop
   begin
      0
      10 for
         100 ms
         rdpin drop
         rdpin 1690 - +
      next
      crlf 10 / dup . 
      499 + 1000 / . 
      
   KEY until
;
6 := debounce#
0 value oldkey#
0 value samekey#
0 value keyCnt#

: aGetKey.old {: , k# -- key } \ 0 for none, 1...6
   keysPin pin
   
   10_000 adcDrive 
   
   begin \ 6 times same key, debounce and bad contact
      debounce# ms
      rdpin 1690 - 499 + 1000 / to k#
      debounce# ms rdpin 1690 - 499 + 1000 / k# =
      debounce# ms rdpin 1690 - 499 + 1000 / k# = and
      debounce# ms rdpin 1690 - 499 + 1000 / k# = and  
      debounce# ms rdpin 1690 - 499 + 1000 / k# = and 
      debounce# ms rdpin 1690 - 499 + 1000 / k# = and       
   until
   k# oldkey# <> if 
      k# dup to oldkey# 
   else 0 then
;


: aGetKey {: , k# -- key } \ 0 for none, 1...6
   keysPin pin
   
   10_000 adcDrive 
   
   debounce# ms
   rdpin 1690 - 499 + 1000 / to k#
      
   k# samekey# = if 
      1 +to keyCnt#
   else 
      0 to keyCnt# 
      k# to samekey# 
   then
   keyCnt# 6 >  k# oldkey# <> and if
      k# dup to oldkey# 
      0 to keyCnt#
   else 0 then
;

   
: scanA 
   key drop
   begin
      aGetKey ?dup if . then
   key until
;
      


\ }

